outfile = fopen('boxqp_dnn_stats.csv','w');
fprintf(outfile,'instance, A1_time_per_iter, BV_time_per_iter, A1_time_to_min_LB, BV_time_to_min_LB\n');

!cp ../data/boxqp/basic/*.in .
!cp ../data/boxqp/extended/*.in .
!cp ../data/boxqp/extended2/*.in .

infiles = dir('*.in');

for i = 1 : length(infiles)

  str1 = strcat('../tests/paper/boxqp/dnn/'    ,infiles(i).name,'.out');
  str2 = strcat('../tests/BurVan09_boxqp/dnn/',infiles(i).name,'.out');

  if exist(str1,'file') > 0 & exist(str2,'file') > 0

    %% ------------------
    %% Extract total time
    %% ------------------

    %% Algorithm 1

    strexec = strcat( [ '!grep ''e.*e.*e'' ', str1, ' | tail -1 > tmp.txt' ]);
    eval(strexec);

    [fid,msg] = fopen('tmp.txt');
    if length(msg) > 0
      error('Got error\n');
    end

    tmp = textscan(fid,'iter = %f  LB = %f  time = %f  norm = %f  sig = %f');

    fclose(fid);

    time1 = tmp{3};

    %% Burer-Vandenbussche

    strexec = strcat( [ '!grep ''B&B CPU Time'' ', str2, ' > tmp.txt' ]);
    eval(strexec);

    [fid,msg] = fopen('tmp.txt');
    if length(msg) > 0
      error('Got error\n');
    end

    tmp = textscan(fid,'B&B CPU Time = %f');

    fclose(fid);

    time2 = tmp{1};

    %% ------------------
    %% Extract iterations
    %% ------------------

    %% Algorithm 1

    strexec = strcat( [ '!grep ''iter = '' ', str1, ' | tail -1 > tmp.txt' ]);
    eval(strexec);

    [fid,msg] = fopen('tmp.txt');
    if length(msg) > 0
      error('Got error\n');
    end

    tmp = textscan(fid,'iter = %f LB = %f time = %f norm = %f sig = %f');

    fclose(fid);

    iter1 = tmp{1};

    %% Burer-Vandenbussche

    strexec = strcat( [ '!egrep ''e.*e.*e.*e.*e'' ', str2, ' | tail -1 > tmp.txt' ]);
    eval(strexec);

    [fid,msg] = fopen('tmp.txt');
    if length(msg) > 0
      error('Got error\n');
    end

    tmp = textscan(fid,'%f %f %f %f %f %f %f');

    fclose(fid);

    iter2 = tmp{1};

    %% ---------------------
    %% Extract per-iter info
    %% ---------------------

    %% Algorithm 1

    strexec = strcat( [ '!grep ''iter = '' ', str1, ' > tmp.txt' ]);
    eval(strexec);

    [fid,msg] = fopen('tmp.txt');
    if length(msg) > 0
      error('Got error\n');
    end

    tmp = textscan(fid,'iter = %f LB = %f time = %f norm = %f sig = %f');

    fclose(fid);

    info1 = [tmp{1}, tmp{2}, tmp{3}];

    %% Burer-Vandenbussche

    strexec = strcat( [ '!grep ''e.*e.*e.*e.*e'' ', str2, ' > tmp.txt' ]);
    eval(strexec);

    [fid,msg] = fopen('tmp.txt');
    if length(msg) > 0
      error('Got error\n');
    end

    tmp = textscan(fid,'%f %f %f %f %f %f %f');

    fclose(fid);

    info2 = [tmp{1}, -tmp{3}, tmp{7}];

    %% ---------------------------------------------------------------
    %% Trim per-iter info (up to minimum of two lower bounds achieved)
    %% ---------------------------------------------------------------
  
    LB = min( [ info1(end,2), info2(end,2) ] );

    ind1 = find( info1(:,2) <= LB);
    info1 = info1(ind1,:);

    ind2 = find( info2(:,2) <= LB);
    info2 = info2(ind2,:);

    %% Save

    results{i,1} = infiles(i).name;
    results{i,2} = time1/iter1;
    results{i,3} = time2/iter2;
    results{i,4} = max(1,info1(end,3));
    results{i,5} = max(1,info2(end,3));

    %% Print
    fprintf(outfile,'%s, %.15e, %.15e, %.2f, %.2f\n', results{i,1}, results{i,2}, results{i,3}, results{i,4}, results{i,5});

  end

end

fclose(outfile);

!rm -rf *.in
!rm -rf tmp.txt
